librccui.h File Reference
`#include <librcc.h>`

Go to the source code of this file.

## Classes

struct | rcc_name_t
struct | rcc_option_name_t
struct | rcc_ui_language_frame_name_t
struct | rcc_ui_charset_frame_name_t
struct | rcc_ui_engine_frame_name_t
struct | rcc_ui_page_name_t

## Typedefs

typedef struct rcc_ui_context_t * | rcc_ui_context
typedef struct rcc_name_t | rcc_name
typedef const char * | rcc_option_value_name
typedef rcc_option_value_name * | rcc_option_value_names
typedef struct rcc_option_name_t | rcc_option_name
typedef const char * | rcc_ui_box_name
typedef struct rcc_ui_language_frame_name_t | rcc_ui_language_frame_name
typedef struct rcc_ui_charset_frame_name_t | rcc_ui_charset_frame_name
typedef struct rcc_ui_engine_frame_name_t | rcc_ui_engine_frame_name
typedef struct rcc_ui_page_name_t | rcc_ui_page_name
typedef void * | rcc_ui_widget
typedef void * | rcc_ui_box
typedef void * | rcc_ui_frame
typedef void * | rcc_ui_page

## Functions

int | rccUiSetLanguageNames (rcc_ui_context ctx, rcc_name *names)
int | rccUiSetCharsetNames (rcc_ui_context ctx, rcc_name *names)
int | rccUiSetEngineNames (rcc_ui_context ctx, rcc_name *names)
int | rccUiSetOptionNames (rcc_ui_context ctx, rcc_option_name *names)
int | rccUiSetClassNames (rcc_ui_context ctx)
rcc_ui_page_name * | rccUiGetDefaultPageName ()
const char * | rccUiGetLanguageName (rcc_ui_context ctx, rcc_language_id language_id)
const char * | rccUiGetClassName (rcc_ui_context ctx, rcc_class_id class_id)
const char * | rccUiGetCharsetName (rcc_ui_context ctx, rcc_language_id language_id, rcc_class_id class_id, rcc_charset_id charset_id)
const char * | rccUiGetEngineName (rcc_ui_context ctx, rcc_language_id language_id, rcc_engine_id engine_id)
const char * | rccUiGetOptionName (rcc_ui_context ctx, rcc_option option)
const char * | rccUiGetOptionValueName (rcc_ui_context ctx, rcc_option option, rcc_option_value value)
int | rccUiInit ()
void | rccUiFree ()
rcc_ui_context | rccUiCreateContext (rcc_context rccctx)
void | rccUiFreeContext (rcc_ui_context ctx)
int | rccUiHideOption (rcc_ui_context ctx, rcc_option option)
int | rccUiUnHideOption (rcc_ui_context ctx, rcc_option option)
int | rccUiRestoreLanguage (rcc_ui_context ctx)
int | rccUiRestore (rcc_ui_context ctx)
int | rccUiUpdate (rcc_ui_context ctx)
rcc_ui_widget | rccUiGetLanguageMenu (rcc_ui_context ctx)
rcc_ui_widget | rccUiGetCharsetMenu (rcc_ui_context ctx, rcc_class_id id)
rcc_ui_widget | rccUiGetEngineMenu (rcc_ui_context ctx)
rcc_ui_widget | rccUiGetOptionMenu (rcc_ui_context ctx, rcc_option option)
rcc_ui_box | rccUiGetLanguageBox (rcc_ui_context ctx, const char *title)
rcc_ui_box | rccUiGetCharsetBox (rcc_ui_context ctx, rcc_class_id id, const char *title)
rcc_ui_box | rccUiGetEngineBox (rcc_ui_context ctx, const char *title)
rcc_ui_box | rccUiGetOptionBox (rcc_ui_context ctx, rcc_option option, const char *title)
rcc_ui_frame | rccUiGetLanguageFrame (rcc_ui_context ctx, rcc_ui_language_frame_name *name)
rcc_ui_frame | rccUiGetCharsetsFrame (rcc_ui_context ctx, rcc_ui_charset_frame_name *name)
rcc_ui_frame | rccUiGetEngineFrame (rcc_ui_context ctx, rcc_ui_engine_frame_name *name)
rcc_ui_page | rccUiGetPage (rcc_ui_context ctx, rcc_ui_page_name *name)

## Typedef Documentation

## rcc_name

typedef struct rcc_name_t rcc_name

## rcc_option_name

typedef struct rcc_option_name_t rcc_option_name

## rcc_option_value_name

typedef const char* rcc_option_value_name

## rcc_option_value_names

typedef rcc_option_value_name* rcc_option_value_names

## rcc_ui_box

typedef void* rcc_ui_box

## rcc_ui_box_name

typedef const char* rcc_ui_box_name

## rcc_ui_charset_frame_name

typedef struct rcc_ui_charset_frame_name_t rcc_ui_charset_frame_name

## rcc_ui_context

typedef struct rcc_ui_context_t* rcc_ui_context

## rcc_ui_engine_frame_name

typedef struct rcc_ui_engine_frame_name_t rcc_ui_engine_frame_name

## rcc_ui_frame

typedef void* rcc_ui_frame

## rcc_ui_language_frame_name

typedef struct rcc_ui_language_frame_name_t rcc_ui_language_frame_name

## rcc_ui_page

typedef void* rcc_ui_page

## rcc_ui_page_name

typedef struct rcc_ui_page_name_t rcc_ui_page_name

## rcc_ui_widget

typedef void* rcc_ui_widget

## Function Documentation

## rccUiCreateContext()

rcc_ui_context rccUiCreateContext | ( | rcc_context | rccctx | ) |

Create UI context and attach it to RCC working context. It isn't permited to attach to single working context several UI's.

Parameters

  rccctx | is pointer on the RCC working context.

Returns
  pointer on newly created UI context or NULL in the case of errors.

Referenced by main().

## rccUiFree()

void rccUiFree | ( |  | ) |

Free resources used by UI library.

Returns
  non-zero value in the case of error.

Referenced by main().

## rccUiFreeContext()

void rccUiFreeContext | ( | rcc_ui_context | ctx | ) |

Destroy UI context and free all memory used.

Parameters

  ctx | is UI context to be destroyed.

Referenced by main().

## rccUiGetCharsetBox()

rcc_ui_box rccUiGetCharsetBox | ( | rcc_ui_context | ctx,
|  | rcc_class_id | id,
|  | const char * | title )

## rccUiGetCharsetMenu()

rcc_ui_widget rccUiGetCharsetMenu | ( | rcc_ui_context | ctx,
|  | rcc_class_id | id )

## rccUiGetCharsetName()

const char * rccUiGetCharsetName | ( | rcc_ui_context | ctx,
|  | rcc_language_id | language_id,
|  | rcc_class_id | class_id,
|  | rcc_charset_id | charset_id )

## rccUiGetCharsetsFrame()

rcc_ui_frame rccUiGetCharsetsFrame | ( | rcc_ui_context | ctx,
|  | rcc_ui_charset_frame_name * | name )

## rccUiGetClassName()

const char * rccUiGetClassName | ( | rcc_ui_context | ctx,
|  | rcc_class_id | class_id )

## rccUiGetDefaultPageName()

rcc_ui_page_name * rccUiGetDefaultPageName | ( |  | ) |

## rccUiGetEngineBox()

rcc_ui_box rccUiGetEngineBox | ( | rcc_ui_context | ctx,
|  | const char * | title )

## rccUiGetEngineFrame()

rcc_ui_frame rccUiGetEngineFrame | ( | rcc_ui_context | ctx,
|  | rcc_ui_engine_frame_name * | name )

## rccUiGetEngineMenu()

rcc_ui_widget rccUiGetEngineMenu | ( | rcc_ui_context | ctx | ) |

## rccUiGetEngineName()

const char * rccUiGetEngineName | ( | rcc_ui_context | ctx,
|  | rcc_language_id | language_id,
|  | rcc_engine_id | engine_id )

## rccUiGetLanguageBox()

rcc_ui_box rccUiGetLanguageBox | ( | rcc_ui_context | ctx,
|  | const char * | title )

## rccUiGetLanguageFrame()

rcc_ui_frame rccUiGetLanguageFrame | ( | rcc_ui_context | ctx,
|  | rcc_ui_language_frame_name * | name )

## rccUiGetLanguageMenu()

rcc_ui_widget rccUiGetLanguageMenu | ( | rcc_ui_context | ctx | ) |

## rccUiGetLanguageName()

const char * rccUiGetLanguageName | ( | rcc_ui_context | ctx,
|  | rcc_language_id | language_id )

## rccUiGetOptionBox()

rcc_ui_box rccUiGetOptionBox | ( | rcc_ui_context | ctx,
|  | rcc_option | option,
|  | const char * | title )

## rccUiGetOptionMenu()

rcc_ui_widget rccUiGetOptionMenu | ( | rcc_ui_context | ctx,
|  | rcc_option | option )

## rccUiGetOptionName()

const char * rccUiGetOptionName | ( | rcc_ui_context | ctx,
|  | rcc_option | option )

## rccUiGetOptionValueName()

const char * rccUiGetOptionValueName | ( | rcc_ui_context | ctx,
|  | rcc_option | option,
|  | rcc_option_value | value )

## rccUiGetPage()

rcc_ui_page rccUiGetPage | ( | rcc_ui_context | ctx,
|  | rcc_ui_page_name * | name )

Get UI option page which can be integrated in application GUI. It is up on the caller to use and destroy returned page.

Parameters

  ctx | is UI context.
  name | provides titles which should be used on the page or NULL to use defaults.

Returns
  is created UI page or NULL in the case of errors.

Referenced by main().

## rccUiHideOption()

int rccUiHideOption | ( | rcc_ui_context | ctx,
|  | rcc_option | option )

## rccUiInit()

int rccUiInit | ( |  | ) |

Init RCC User Interface Library. This function should be called prior to any other UI functions

Referenced by main().

## rccUiRestore()

int rccUiRestore | ( | rcc_ui_context | ctx | ) |

Restores complete UI configuration from rcc_context.

Parameters

  ctx | is UI context.

## rccUiRestoreLanguage()

int rccUiRestoreLanguage | ( | rcc_ui_context | ctx | ) |

Restores current language UI menu values from rcc_context.

Parameters

  ctx | is UI context.

## rccUiSetCharsetNames()

int rccUiSetCharsetNames | ( | rcc_ui_context | ctx,
|  | rcc_name * | names )

## rccUiSetClassNames()

int rccUiSetClassNames | ( | rcc_ui_context | ctx | ) |

## rccUiSetEngineNames()

int rccUiSetEngineNames | ( | rcc_ui_context | ctx,
|  | rcc_name * | names )

## rccUiSetLanguageNames()

int rccUiSetLanguageNames | ( | rcc_ui_context | ctx,
|  | rcc_name * | names )

## rccUiSetOptionNames()

int rccUiSetOptionNames | ( | rcc_ui_context | ctx,
|  | rcc_option_name * | names )

## rccUiUnHideOption()

int rccUiUnHideOption | ( | rcc_ui_context | ctx,
|  | rcc_option | option )

Referenced by main().

## rccUiUpdate()

int rccUiUpdate | ( | rcc_ui_context | ctx | ) |

Updates rcc_context with user adjusted options from UI configuration.

Parameters

  ctx | is UI context.